function AutoCompleteDB()
{
	this.bEnd = false;
	this.nCount = 0;
	this.aStr = new Object;
}



AutoCompleteDB.prototype.add = function(str)
{
	this.nCount++;

	if ( str == "" ) {
		this.bEnd = true;
	}
	else {
		var letter = str.substring(0,1);
		var rest = str.substring(1,str.length);

		if (!this.aStr[letter]) {
			this.aStr[letter] = new AutoCompleteDB();
		}
		this.aStr[letter].add(rest);
	}
}


AutoCompleteDB.prototype.getCount = function(str, bExact)
{
	if ( str == "" ) {
		if ( this.bEnd && bExact && (this.nCount == 1) ) {
			return 0;
		}
		else {
			return this.nCount;
		}
	}
	
	var letter = str.substring(0,1);
	var rest = str.substring(1,str.length);
	
	var nCount = 0;
	var lLetter = letter.toLowerCase();
	if ( this.aStr[lLetter] ) {
		nCount += this.aStr[lLetter].getCount(rest, bExact && (letter == lLetter));
	}
	
	var uLetter = letter.toUpperCase();
	if ( this.aStr[uLetter] ) {
		nCount += this.aStr[uLetter].getCount(rest, bExact && (letter == uLetter));
	}
	
	return nCount;	
}


AutoCompleteDB.prototype.getStrings = function(str1, str2, outStr)
{
	if ( str1 == "" )
	{
		if ( this.bEnd ) 
			outStr.push(str2);

		for ( var i in this.aStr )
			this.aStr[i].getStrings(str1, str2 + i, outStr);
	}
	else
	{
		var letter = str1.substring(0,1);
		var rest = str1.substring(1,str1.length);

		var lLetter = letter.toLowerCase();
		if ( this.aStr[lLetter] )
			this.aStr[lLetter].getStrings(rest, str2 + lLetter, outStr);

		var uLetter = letter.toUpperCase();
		if ( this.aStr[uLetter] )
			this.aStr[uLetter].getStrings(rest, str2 + uLetter, outStr);
	}
}



function AutoComplete(aStr, oText, oDiv, nMaxSize)
{
	this.oText = oText;
	this.oDiv = oDiv;
	this.nMaxSize = nMaxSize;
	
	this.db = new AutoCompleteDB();
	var i, n = aStr.length;
	for ( i = 0; i < n; i++ ) {
		this.db.add(aStr[i]);
	}

	oText.AutoComplete = this;
	oText.onkeyup = AutoComplete.prototype.onTextChange;

	oText.onblur = AutoComplete.prototype.onblur;
	oDiv.onblur = AutoComplete.prototype.onblur;
}




var autoComp;
var selectPos = -1;
var boxSize = 0;


AutoComplete.prototype.onTextBlur = function()
{
	this.AutoComplete.onblur();
}

AutoComplete.prototype.onblur = function()
{
	if (autoComp && autoComp.oDiv){
		autoComp.oDiv.style.visibility = "hidden";
	}
}


AutoComplete.prototype.onTextChange = function()
{
	var chr0 = event.keyCode;
	if (chr0 == 13) {
		return;
	}
	this.AutoComplete.onchange();
}


AutoComplete.prototype.onDivMouseDown = function()
{
	this.AutoComplete.oText.value = this.innerHTML;
	this.AutoComplete.oDiv.style.visibility = "hidden";
}


AutoComplete.prototype.onDivMouseOver = function()
{
	for (var i=0; i<boxSize; i++) {
		var div = document.getElementById(i);
		if (div) {
			div.className = "AutoCompleteBackground";
		}
	}
	this.className = "AutoCompleteHighlight";
	selectPos = this.id;
}


AutoComplete.prototype.onDivMouseOut = function()
{
	this.className = "AutoCompleteBackground";
	seletcPos = -1;
}


AutoComplete.prototype.onchange = function()
{
	var txt = this.oText.value;
	var nCount = this.db.getCount(txt, true);
	
	if ((this.nMaxSize == -1 ) || ((nCount < this.nMaxSize) && (nCount > 0))) {
		while ( this.oDiv.hasChildNodes() ) {
			this.oDiv.removeChild(this.oDiv.firstChild);
		}

		var aStr0 = new Array();
		this.db.getStrings(txt, "", aStr0);
		var i, j;
		var aStr = new Array();
		var n00, n0 = aStr0.length;
		for (i = 0; i < n0; i++) {
			n00 = aStr.length;
			var word = aStr0[i];
			for (j = 0; j < n00; j++) {
				if (aStr[j] == word) {
					break;
				}
			}
			if (j == n00) {
				aStr.push(word);
			}
		}

		var n = aStr.length;
		for (i=0; i<n; i++) {
			var oDiv = document.createElement('div');
			this.oDiv.appendChild(oDiv);
			oDiv.innerHTML = aStr[i];
			oDiv.onmousedown = AutoComplete.prototype.onDivMouseDown;
			oDiv.onmouseover = AutoComplete.prototype.onDivMouseOver;
			oDiv.onmouseout = AutoComplete.prototype.onDivMouseOut;

			oDiv.AutoComplete = this;
			oDiv.id = i;
			if (selectPos != -1 && i == selectPos) {
				oDiv.className = "AutoCompleteHighlight";
			}
		}
		this.oDiv.style.visibility = "visible";

		boxSize = aStr.length;
	}
	else {
		this.oDiv.innerHTML = "";
		this.oDiv.style.visibility = "hidden";
	}
}



function key_get() {
	chr0 = event.keyCode;

	if (autoComp != null && autoComp.oDiv != null) {
		if (autoComp.oDiv.style.visibility != 'hidden') {
			if (chr0 == 13){
				var div = document.getElementById(selectPos);
				if (div) {
					autoComp.oText.value = div.innerText;
				}

				if (autoComp.oDiv) {
					autoComp.oDiv.style.visibility = 'hidden';
				}
			}
			else if (chr0 == 40){
				selectPos = parseInt(selectPos);
				if (selectPos != null && selectPos + 1 < boxSize) {
					var oldPos = selectPos;
					selectPos = selectPos + 1;

					var div = document.getElementById(selectPos);
					if (div) {
						div.className = "AutoCompleteHighlight";
					}
					var oldDiv = document.getElementById(oldPos);
					if (oldDiv) {
						oldDiv.className = "AutoCompleteBackground";
					}
				}
				else if (selectPos == -1 && boxSize > 0){
					selectPos = 0;
					var div = document.getElementById(selectPos);
					if (div) {
						div.className = "AutoCompleteHighlight";
					}
				}
			}
			else if (chr0 == 38){
				selectPos = parseInt(selectPos);
				if (selectPos != null && selectPos - 1 > -1) {
					var oldPos = selectPos;
					selectPos = selectPos - 1;

					var div = document.getElementById(selectPos);
					if (div) {
						div.className = "AutoCompleteHighlight";
					}
					var oldDiv = document.getElementById(oldPos);
					if (oldDiv) {
						oldDiv.className = "AutoCompleteBackground";
					}
				}
			}
		} 
	}
}

window.document.onkeydown = key_get;

