var audioList = new Array();

function audioEntry(audioID) 
{
	this.audioID = audioID;
	this.bMute = false;
	this.bRepeat = false;
	this.bPaused = false;
	this.bStarted = true;
	this.bFinished = false;
	this.bsliderDownV = false;

	this.CURRENTVOL = 100;
	this.speedDefault = 2;
	this.speedIndex = 2;
	this.speedArray = [0.5, 0.75, 1.0, 1.5, 2.0];
	
	this.slowButton = document.getElementById(audioID + "_slowButton");
	this.fastButton = document.getElementById(audioID + "_fastButton");
	this.vSlider = document.getElementById(audioID + "_vSlider");

	function speedChange(index){
		var nextIndex = this.speedIndex + index;
		if (nextIndex < 0) {
			nextIndex = 0;
		} 
		else if (nextIndex >= this.speedArray.length) {
			nextIndex = this.speedArray.length - 1;
		}

			this.speedChangeByIndex(nextIndex);
	}
	
	function speedChangeByIndex(index){
		var speedValue = this.speedArray[index];
		var audioElem = document.getElementById(audioID);
		audioElem.speed = speedValue;

		this.slowButton.title = 'Đx:' + Math.round(speedValue * 1000) / 1000 + '{';
		this.fastButton.title = 'Đx:' + Math.round(speedValue * 1000) / 1000 + '{';
		this.speedIndex = index;
	}
	
	this.speedChange = speedChange;
	this.speedChangeByIndex = speedChangeByIndex;
}


function addAudioEntry(audioID)
{
	if (audioList[audioID] == null) {
		var audioObj = new audioEntry(audioID);
		audioList[audioID] = audioObj;
	}
}



function getAudioID(obj)
{
	var length = obj.id.length;
	var endPos = length - 1;
	var c; 
	for(var i=endPos; i>=0; i--){
		c = obj.id.charAt(i);
		if(c == '_'){
			return obj.id.substring(0,i);
		}
	}
	return null;
}


function getAudio(obj)
{
	var getAudio;
	if (typeof(obj) == "string") {
		getAudio = obj;
	} else {
		getAudio = getAudioID(obj);
	}
	return audioList[getAudio];
}



function audioPlayDown(obj)
{
	var audio = getAudio(obj);
	var audioElem = document.getElementById(audio.audioID);

	if (audioElem != null && audio.bPaused == true) {
		imgSwap(audio.audioID+ "_playButton", pauseImgOn.src);
	} else{
		imgSwap(audio.audioID + "_playButton", playImgOn.src);
	}

	return true;
}

function audioPlayUp(obj) 
{
	if (playAudio(obj)) {
		return true;
	} else {
		audioPauseUp(obj);
	}
}



function playAudio(obj) 
{
	var audio = getAudio(obj);
	var audioElem = document.getElementById(audio.audioID);

	if (audioElem != null)
	{
		if (audio.bFinished) {
			imgSwap(audio.audioID + "_playButton", pauseImgOff.src);
			var playButton = document.getElementById(audio.audioID + "_playButton");
			playButton.title = 'ꎞ~';

			audio.bStarted = true;
			audio.bFinished = false;
			audioElem.beginElement();

			if (audio.bMute) {
				audioElem.volume = 0;
			} else {
				audioElem.volume = audio.CURRENTVOL;
			}

			return true;
		}
		else if (audio.bPaused) {
			imgSwap(audio.audioID + "_playButton", pauseImgOff.src);
			var playButton = document.getElementById(audio.audioID + "_playButton");
			playButton.title = 'ꎞ~';

			audio.bPaused = false;
			audioElem.resumeElement();
			
			if (audio.bMute) {
				audioElem.volume = 0;
			} else  {
				audioElem.volume = audio.CURRENTVOL;
			}

			return true;
		}
	}

	return false;
}


function audioPauseUp(obj)
{
	var audio = getAudio(obj);
	var audioElem = document.getElementById(audio.audioID);

	if (!audio.bPaused && !audio.bFinished && audio.bStarted){
		imgSwap(audio.audioID + "_playButton", playImgOff.src);
		var playButton = document.getElementById(audio.audioID + "_playButton");
		playButton.title = 'Đ';

		audio.bPaused = true;
		audioElem.pauseElement();
	}
}


function audioPauseEvent(obj)
{
	var audio = getAudio(obj);
	if (audio.bFinished) {
		return;
	} else {
		audioPauseUp(obj);
	}
}

function audioResumeEvent(obj)
{
	var audio = getAudio(obj)
	if (audio.bFinished) {
		return;
	} else {
		playAudio(obj);
	}
}



function audioStopDown(obj)
{
	var audio = getAudio(obj);
	var audioElem = document.getElementById(audio.audioID);

	imgSwap(audio.audioID + "_stopButton", stopImgOn.src);
	audioStop(obj);
}

function audioStop(obj)
{
	var audio = getAudio(obj);
	var audioElem = document.getElementById(audio.audioID);

	imgSwap(audio.audioID + "_playButton", playImgOff.src);
	imgSwap(audio.audioID + "_repeatButton", repeatImgOff.src);
	var playButton = document.getElementById(audio.audioID + "_playButton");
	playButton.title = 'Đ';
 
	audio.speedChangeByIndex(audio.speedDefault);

	audio.bMute = false;
	audioElem.volume = audio.CURRENTVOL;
	imgSwap(audio.audioID + "_soundButton", soundImgOn.src);
	var soundButton = document.getElementById(audio.audioID + "_soundButton");
	soundButton.title = 'ON';

	audio.bFinished = true;
	audio.bStarted = false;
	audio.bPaused = false;
	audio.bRepeat = false;
	audioElem.endElement();
}

function audioStopUp(obj)
{
	var audio = getAudio(obj);
	imgSwap(audio.audioID + "_stopButton", stopImgOff.src);
	imgSwap(audio.audioID + "_playButton", playImgOff.src);
}

function endAudio(obj)
{
	var audioID = obj.id;
	var audio = getAudio(audioID);
	if (audio == null || typeof(audio) == "undefined") {
		return;
	}

	var audioElem = document.getElementById(audio.audioID);

	if (audio.bFinished == false)
	{
		if (audio.bRepeat) {
			audioElem.beginElement();
		} else {
			imgSwap(audio.audioID + "_playButton", playImgOff.src);
			var playButton = document.getElementById(audio.audioID + "_playButton");
			playButton.title = 'Đ';

			audio.bFinished = true;
			audio.bStarted = false;
			audio.bPaused = false;
			audioElem.endElement();
		
			audio.speedChangeByIndex(audio.speedDefault);
		}
	}
}


function audioSpeedSlowDown(obj)
{
	var audio = getAudio(obj);
	imgSwap(audio.audioID+ "_slowButton", speedSlowOn.src);
	audioSpeedSlow(obj);
	return true;
}

function audioSpeedSlow(obj) 
{
	var audio = getAudio(obj);
	audio.speedChange(-1);
}

function audioSpeedSlowUp(obj) 
{
	var audio = getAudio(obj);
	imgSwap(audio.audioID+ "_slowButton", speedSlowOff.src);
	return true;
}


function audioSpeedFastDown(obj)
{
	var audio = getAudio(obj);
	imgSwap(audio.audioID + "_fastButton", speedFastOn.src);
	audioSpeedFast(obj);
	return true;
}

function audioSpeedFast(obj) 
{
	var audio = getAudio(obj);
	audio.speedChange(1);
}

function audioSpeedFastUp(obj)
{
	var audio = getAudio(obj);
	imgSwap(audio.audioID + "_fastButton", speedFastOff.src);
	return true;
}

function audioRepeatDown(obj)
{
	var audio = getAudio(obj);

	if (!audio.bRepeat){
	 	imgSwap(audio.audioID + "_repeatButton", repeatImgOn.src);
		audio.bRepeat = true;
	} else {
	 	imgSwap(audio.audioID + "_repeatButton", repeatImgOff.src);
		audio.bRepeat = false;
	}
}

function audioRepeatUp(obj)
{
	return true;
}

function audioSoundDown(obj) 
{
	var audio = getAudio(obj);
	var audioElem = document.getElementById(audio.audioID);

	if (audio.bMute == false) {
		audio.bMute = true;
		audioElem.volume = 0;
		imgSwap(audio.audioID + "_soundButton", soundImgOff.src);
		var soundButton = document.getElementById(audio.audioID + "_soundButton");
		soundButton.title = 'OFF';
	} 
	else {
		audio.bMute = false;
		audioElem.volume = audio.CURRENTVOL;
		imgSwap(audio.audioID + "_soundButton", soundImgOn.src);
		var soundButton = document.getElementById(audio.audioID + "_soundButton");
		soundButton.title = 'ON';
	}
}

function audioSoundUp(obj) 
{
	return true;
}

function audioSoundChange(obj, vol)
{
	var audio = getAudio(obj);
	var audioElem = document.getElementById(audio.audioID);

	if (audio.bMute == false && vol > 0) {
		audioElem.volume = vol;
	}
}

function audioStepBackUp(obj)
{
	var audio = getAudio(obj);
	img = document.getElementById(audio.audioID + "_stepBackButton");

	//if (img.src == stepBackImgOn.src) {
		imgSwap(audio.audioID + "_stepBackButton", stepBackImgOff.src);
		audioStepToTime(audio.audioID, -5);
	//}
	return true;
}

function audioStepBackDown(obj)
{
	var audio = getAudio(obj);
	imgSwap(audio.audioID + "_stepBackButton", stepBackImgOn.src);
	return true;
}

function audioStepForwardUp(obj)
{
	var audio = getAudio(obj);
	img = document.getElementById(audio.audioID + "_stepForwardButton");

	//if (img.src == stepForwardImgOn.src) {
		imgSwap(audio.audioID + "_stepForwardButton", stepForwardImgOff.src);
		audioStepToTime(audio.audioID, 5);
	//}
	return true;
}

function audioStepForwardDown(obj)
{
	var audio = getAudio(obj);
	imgSwap(audio.audioID + "_stepForwardButton", stepForwardImgOn.src);
	return true;
}

function audioStepToTime(obj, plusTime)
{
	var audio = getAudio(obj);
	var audioElem = document.getElementById(audio.audioID);
	var t = audioElem.currTimeState.segmentTime;

	if (audioElem.currTimeState.isActive) {
		var seekTime = t + plusTime;
		audioElem.seekActiveTime(seekTime);
	}
}




function audioVolumeSliderMouseDown(obj)
{
	var audio = getAudio(obj);
	audio.bsliderDownV = true;

	audio.vSlider.scrollXvalue = document.body.scrollLeft;
	audio.vSlider.scrollYvalue = document.body.scrollTop;
}


function audioVolumeSliderMouseUp(obj) 
{
	var audio = getAudio(obj);
	if (audio == null) {
		return true;
	}

	var vol = parseInt(audio.vSlider.value);
	audio.CURRENTVOL = vol;
	audio.vSlider.title = vol;

	if (audio.bStarted && audio.bsliderDownV) 
	{
		if (!audio.bMute) {
			var audioElem = document.getElementById(audio.audioID);
			audioElem.volume = vol;
		}
		audio.bsliderDownV = false;
	}
}



function audioUISetup(audioID, height, width, top, left, uicolor, bPlay, bStop, bVol, bSpeed, bRepeat, bMute)
{
	if (videoLevel == 1) {
	   bMute = false;
	   bVol  = false;
	}

	requestedWidth[audioID] = width;
	requestedHeight[audioID] = height;

	var panel = document.getElementById(audioID + "_ControlPanel");
	var topBar = document.getElementById(audioID + "_MenuBar");
	var uiVSlider = document.getElementById(audioID + "_vSlider");
	panel.style.display = "block";
	panel.style.top = top;
	panel.style.left = left;

	if (isImage(uicolor)) {
		panel.style.backgroundColor = "transparent";
		uiVSlider.style.backgroundColor = "transparent";
		panel.style.backgroundImage = "url('" + uicolor + "')";
	} else{
		panel.style.backgroundColor = uicolor;
		uiVSlider.style.backgroundColor = uicolor;
	}

	uitoggle(audioID + "_playButton", bPlay);
	uitoggle(audioID + "_stopButton", bStop);

	ctrlObj = document.getElementById(audioID + "_oLeft");
	if (ctrlObj) {
		if(bSeek){
			ctrlObj.style.display = 'inline';
		}else{
			ctrlObj.style.display = 'none';
		}
	}
	ctrlObj = document.getElementById(audioID + "_oRight");
	if(ctrlObj){
		if(bSeek){
			ctrlObj.style.display = 'inline';
		}else{
			ctrlObj.style.display = 'none';
		}
	}

	uitoggle(audioID + "_repeatButton", bRepeat);
	uitoggle(audioID + "_slowButton", bSpeed);
	uitoggle(audioID + "_fastButton", bSpeed);
	uitoggle(audioID + "_soundButton", bMute);
	uitoggle(audioID + "_vSlider", bVol);

	ctrlObj = document.getElementById(audioID + "_vLeft");
	if (ctrlObj) {
		if(bVol){
			ctrlObj.style.display = 'inline';
		}else{
			ctrlObj.style.display = 'none';
		}
	}
	ctrlObj = document.getElementById(audioID + "_vRight");
	if (ctrlObj) {
		if(bVol){
			ctrlObj.style.display = 'inline';
		}else{
			ctrlObj.style.display = 'none';
		}
	}

	r2Count = (bRepeat ? 1 : 0) + (bSpeed ? 2 : 0) + (bMute ? 1 : 0) + (bVol ? 1 : 0);
	var callString = "widthCalculate('" + audioID + "');";
	timerID = setTimeout(callString, 200);
	heightCalculate(audioID);

	ctrlObj = document.getElementById(audioID + "_lbot");
	if(ctrlObj){
		if(bSeek){
			ctrlObj.style.top = 45;
		}else{
			ctrlObj.style.top = 21;
		}
	}
	ctrlObj = document.getElementById(audioID + "_rbot");
	if(ctrlObj){
		if(bSeek){
			ctrlObj.style.top = 45;
		}else{
			ctrlObj.style.top = 21;
		}
		ctrlObj.style.left = width - 7;
	}
}



