var defaultWIDTH = 352;
var defaultHEIGHT = 240;

var INITIALIZED = false;
var UNLOADING = false;
var BASERESOURCE = "";


var firstRow = ['oSlider']; 
var secondRow = ['playButton','stopButton','prevButton', 'nextButton', 'repeatButton', 'slowButton', 'fastButton', 'soundButton','vSlider'];
var r2Count = 0;
var videolist = new Object();
var uiHashtable = new Object();
var requestedWidth = new Object();
var requestedHeight = new Object();


// UI images
var playImgOn = new Image();
var playImgOff = new Image();
var playImgOver = new Image();
var pauseImgOn = new Image();
var pauseImgOff = new Image();
var pauseImgOver = new Image();
var stopImgOn = new Image();
var stopImgOff = new Image();
var stopImgOver = new Image();
var prevImgOn = new Image();
var prevImgOff = new Image();
var prevImgOver = new Image();
var nextImgOn = new Image();
var nextImgOff = new Image();
var nextImgOver = new Image();
var repeatImgOn = new Image();
var repeatImgOff = new Image();
var repeatImgOver = new Image();
var speedFastOn = new Image();
var speedFastOff = new Image();
var speedFastOver = new Image();
var speedSlowOn = new Image();
var speedSlowOff = new Image();
var speedSlowOver = new Image();
var soundImgOn = new Image();
var soundImgOff = new Image();
var soundImgOver = new Image();

var stepBackImgOn = new Image();
var stepBackImgOff = new Image();
var stepBackImgOver = new Image();
var stepForwardImgOn = new Image();
var stepForwardImgOff = new Image();
var stepForwardImgOver = new Image();

var showFullImgOn = new Image();
var showFullImgOff = new Image();
var showFullImgOver = new Image();

var PROGRESS_END_CORRECT = 0.030;
var SEEK_AFTER_CORRECT = 0.030;


function getVidID(obj){
	var length = obj.id.length;
	var endPos = length -1;
	var c; 
	for (var i=endPos; i >= 0; i--) {
		c = obj.id.charAt(i);
		if(c == '_'){
			return obj.id.substring(0,i);
		}
	}
	return null;
}

function getVideo(obj){
	var vidid;
	if (typeof(obj) == "string") {
		vidid = obj;
	} else {
		vidid = getVidID(obj);
	}
	return videolist[vidid];
}



function initialize()
{
	for (var vid in videolist) {
		calcTimes(vid);
	}

	listUI();
	INITIALIZED = true;
}

function videoEntry(videoID)
{
	this.videoID = videoID;
	this.TOTALTIME = 0;
	this.TOTALENTRIES = 0;

	this.CURRENTSPEED = 1;
	this.CURRENTVOL = 100;
	this.PRELOADID = null;
	this.NEXTDISABLE = false;
	this.playlist = new Array();
	this.scenelist = new Array(); 

	this.currentEntry = null;
	this.currentScene = null;

	this.movieStarted = false;
	this.moviePaused = false;
	this.movieFinished = false;
	this.movieStoped = false;
	this.timePosition = 0;

	this.bMovieIsActive = false;

	this.buffering = false;
	this.bsliderDown = false;
	this.bsliderDownV = false;
	this.bSeekInProgress = false;
	this.bRepeat = false;
	this.bMute = null;
	this.bAutoStart = false;
	this.autoStartTime = 200;
	this.stopCommand = -1;


	this.animation = document.getElementById(videoID + "_animationMain");
	this.animationTimeline = document.getElementById(videoID + "_animationMainTime");
	this.slider = document.getElementById(videoID + "_oSlider");
	this.indexframe = document.getElementById(videoID + "_indexframe");
	this.scenetime = document.getElementById(videoID + "_scene");
	this.slowButton = document.getElementById(videoID + "_slowButton");
	this.fastButton = document.getElementById(videoID + "_fastButton");

	function addPlaylistEntry(playentry){
		this.playlist[this.playlist.length] = playentry;
	}

	function addScenelistEntry(sceneEntry){
		this.scenelist[this.scenelist.length] = sceneEntry;
	}

	this.speedDefault = 2;
	this.currentSpeedIndex = 2;
	this.speedArray = [0.5,0.75,1.0,1.5,2.0];

	function speedChange(num)
	{
		var newSpeedIndex = this.currentSpeedIndex + num;
		if ((newSpeedIndex<0) || (newSpeedIndex >= this.speedArray.length)) {
			return;
		}

		this.currentSpeedIndex = newSpeedIndex;
		this.CURRENTSPEED = this.speedArray[newSpeedIndex];
		this.updateSpeed();
	}

	function updateSpeed()
	{
		if (this.animationTimeline.speed != this.CURRENTSPEED) {
			this.animationTimeline.speed = this.CURRENTSPEED;
		}
		this.slowButton.title = 'Đx:' + Math.round( this.animationTimeline.speed * 1000) / 1000 + '{';
		this.fastButton.title = 'Đx:' + Math.round( this.animationTimeline.speed * 1000) / 1000 + '{';
	}

	this.addPlaylistEntry = addPlaylistEntry;
	this.addScenelistEntry = addScenelistEntry;
	this.updateSpeed = updateSpeed;
	this.speedChange = speedChange;
}


function sceneEntry(videoID, index, begin, end)
{
	this.videoID = videoID;
	this.index = index;
	this.begin = begin;
	this.end = end;
	this.videoEntryIndex = -1;
	this.videoSeekTo = -1;
}



function playEntry(videoID, index, srcloc) 
{
	this.videoID = videoID;
	this.index = index;
	this.srcLocation = srcloc;
	this.preloaded = false;
	this.useFrames = false;
	this.totalframes = 0;
	this.totaltime = 0;
	this.hybridStartTime = 0;
	this.hybridEndTime = 0;

	function setRange(begin, end) {
		this.begintime = parseFloat(begin);
		this.endtime = parseFloat(end);
		this.totaltime = this.endtime - this.begintime;
		this.endTimeString = this.endtime + "s";
	}

	this.setRange = setRange;
}


function addPlayEntry(videoID, indexNum, movieSrc, start, end)
{
	if (videoLevel != 0) {
		movieSrc = "";
	}

	var vid;
	if (videolist[videoID] == null) {
		vid = new videoEntry(videoID);
		videolist[videoID] = vid;
	} else {
		vid = videolist[videoID];
	}

	playentry = new playEntry(videoID, indexNum, movieSrc);
	playentry.setRange(start, end);
	vid.playlist[indexNum] = playentry;		
}


function addSceneEntry(videoID, indexNum, start, end)
{
	var vid;
	if (videolist[videoID] == null) {
		vid = new videoEntry(videoID);
		videolist[videoID] = vid;
	} else {
		vid = videolist[videoID];
	}
	sceneentry = new sceneEntry(videoID, indexNum, start, end);
	vid.scenelist[indexNum] = sceneentry;		
}



function calcTimes(videoID)
{
	var vid = videolist[videoID];
	vid.TOTALTIME = 0;

	var timetotal = 0;
	var hybridStartTime = 0;

	for (var i=0; i<vid.playlist.length; i++)
	{
		var entry = vid.playlist[i];
		entry.hybridStartTime = hybridStartTime;

		var entryTotaltime = Math.round(entry.totaltime * 1000) / 1000;
		entry.hybridEndTime = entry.hybridStartTime + entryTotaltime;

		timetotal = timetotal + entry.totaltime;
		timetotal = Math.round(timetotal * 1000) / 1000;

		hybridStartTime = timetotal;
	}

	for (var j=0; j<vid.scenelist.length; j++){
		var scene = vid.scenelist[j];
		var starttime = scene.begin;
		var bsceneFound = false;

		for (var k=0; k<vid.playlist.length; k++){
			var entry = vid.playlist[k];
			if ((starttime >= entry.hybridStartTime) && (starttime < entry.hybridEndTime)) {
				var diff = starttime - entry.hybridStartTime;
				scene.videoEntryIndex = k;
				scene.videoSeekTo = entry.begintime + diff;
				bsceneFound = true;
				break;
			}
		}
	}

	timetotal = Math.round(timetotal * 1000) / 1000;

	vid.TOTALTIME = timetotal;
	var aniTimeTotal = timetotal + 5;
	vid.animation.dur = aniTimeTotal + "s";
		
	vid.TOTALENTRIES = vid.playlist.length;
}




function getTime()
{
	if (INITIALIZED) {
		for (var hybridVideo in videolist) {
			updateDisplay(videolist[hybridVideo]);
		}
	}
}


function updateDisplay(hvid)
{
	if (hvid.movieStarted) 
	{
		var t = hvid.animation.currTimeState.segmentTime;
		if (t > hvid.TOTALTIME) {
			t = hvid.TOTALTIME;
		}

		var p = t / hvid.TOTALTIME;
		var slideVal = parseInt(p * 100);
		if (slideVal == 99) {
			slideVal = 100;
		}
		hvid.slider.value = slideVal;
		hvid.slider.title = slideVal;
		hvid.timePosition = slideVal;
	}
}







function playMovie(obj)
{
	var vid = getVideo(obj);

	if (vid.movieFinished && vid.timePosition == 100) {
		stopElements(obj);
		vid.movieFinished = false;
		vid.moviePaused = false;
		vid.movieStarted = true;

		imgSwap(vid.videoID + "_playButton", pauseImgOff.src);
		var playButton = document.getElementById(vid.videoID + "_playButton");
		playButton.title = 'ꎞ~';

		vid.animationTimeline.resumeElement();
		return true;
	}

	if (!vid.movieStarted) {
		beginMovie(obj);
		vid.movieFinished = false;
		vid.moviePaused = false;

		imgSwap(vid.videoID + "_playButton", pauseImgOff.src);
		var playButton = document.getElementById(vid.videoID + "_playButton");
		playButton.title = 'ꎞ~';

		return true;
	}

	if (vid.moviePaused) {
		vid.animationTimeline.resumeElement();
		vid.movieFinished = false;
		vid.moviePaused = false;
		vid.movieStarted = true;

		imgSwap(vid.videoID + "_playButton", pauseImgOff.src);
		var playButton = document.getElementById(vid.videoID + "_playButton");
		playButton.title = 'ꎞ~';

		return true;
	}

	return false;
}


function beginMovie(beginObj)
{
	var vid = getVideo(beginObj);
	vid.animationTimeline.beginElement();
	vid.movieStarted = true;
}

function stopButtonRecover(videoID)
{
	var vid = getVideo(videoID);

	imgSwap(vid.videoID + "_stopButton", stopImgOff.src);
	imgSwap(vid.videoID + "_repeatButton", repeatImgOff.src);
	imgSwap(vid.videoID + "_playButton", playImgOff.src);
	var playButton = document.getElementById(vid.videoID + "_playButton");
	playButton.title = 'Đ';
}

function stopElements(obj)
{
	var vid = getVideo(obj);

	vid.bRepeat = false;
	vid.movieStarted = false;
	vid.moviePaused = true;
	vid.movieFinished = true;

	if (vid && vid.animationTimeline) {
		if (vid.animationTimeline.currTimeState.isActive) {
			vid.animationTimeline.seekActiveTime(0);
			vid.animationTimeline.seekActiveTime(0.015);
		}
		vid.animationTimeline.pauseElement();
	}

	vid.currentEntry = null;
	vid.currentScene = null;
	vid.slider.value = 0;
	vid.slider.title = 0;
	vid.timePosition = 0;
	vid.currentSpeedIndex = vid.speedDefault;
	vid.CURRENTSPEED = 1.0;
	
	updateScene(vid.videoID, 0);
}


function setSpeed(videoID, num)
{
	var vid = getVideo(videoID);
	if(vid){
		vid.CURRENTSPEED = num;
		vid.updateSpeed();
	}
}


function searchScene(obj, seekNum)
{
	var searchVid = getVideo(obj);
	var currTime = searchVid.animation.currTimeState.segmentTime;
	var tempScene = null;
	var maxScene = null;

	if ((seekNum == -1) || (seekNum == 0)){
		for (var i=0; i < searchVid.scenelist.length; i++){
			tempScene = searchVid.scenelist[i];
			if ((!maxScene) && (tempScene.begin < currTime)){
				maxScene = tempScene;
			}
			else if ((maxScene) && (tempScene.begin < currTime) && (tempScene.begin > maxScene.begin)){
				maxScene = tempScene;
			}
		}
	}

	if ((seekNum == 1)) {
		for (var i=0; i<searchVid.scenelist.length; i++){
			tempScene = searchVid.scenelist[i];
			if ((!maxScene) && (tempScene.begin > currTime)){
				maxScene = tempScene;
			}
			else if ((maxScene) && (tempScene.begin > currTime) && (tempScene.begin < maxScene.begin)){
				maxScene = tempScene;
			}
		}
	}
	if (maxScene == null) {
	  return 0;
	}
	
	return maxScene.index;
}


function nextScene(obj, seekNum)
{
	var vid = getVideo(obj);

	if (vid.scenelist.length == 0) {
		return true;
	}

	var number = 0;
	if (!vid.currentScene) {
		number = searchScene(obj, seekNum);
	} else {
		number = vid.currentScene.index + seekNum;
	}

	if (number >= vid.scenelist.length) {
		return;
	}
	else if (number < 0) {
		number = 0;
	}

	vid.movieFinished = false;
	var nextscene = vid.scenelist[number]
	var nextEntry = vid.playlist[nextscene.videoEntryIndex];

	var timeto = nextscene.begin;
	var seekto = nextscene.videoSeekTo;
	vid.NEXTDISABLE = true;
	vid.NEXTDISABLE = false;
	
	seekToEntryNumber(obj, nextscene.videoEntryIndex, seekto, timeto); 
	seekToEntryNumber(obj, nextscene.videoEntryIndex, seekto, timeto + SEEK_AFTER_CORRECT); 
}



function seekToTimeS(seekVidID, seektime) 
{
	var vid = getVideo(seekVidID);

	vid.bMovieIsActive = true;

	playMovie(seekVidID);
	seekToTimeS2(seekVidID, seektime);
}


function seekToTimeS2(seekVidID, seektime) 
{
	var vid = getVideo(seekVidID);

	vid.animationTimeline.pauseElement();
	var beforePaused = vid.moviePaused;
	vid.moviePaused = true;
	seekToTime(seekVidID, seektime);

	var percent = seektime / vid.TOTALTIME;
	percent = Math.round(percent * 1000) / 1000;
	if (percent > 1) {
		percent = 1;
	}

	if (!beforePaused && percent != 1) {
		playMovie(seekVidID);
	}
}


function seekToTime(seekVidID, seektime)
{
	var vid = getVideo(seekVidID);

	var percent = seektime / vid.TOTALTIME;
	percent = Math.round(percent * 1000) / 1000;
	if (percent > 1) {
		percent = 1;
	}

	vid.movieFinished = false;
	seekTimeline(seekVidID, percent);
}




function playDown(obj)
{
	var vid = getVideo(obj);
	if ((vid.moviePaused)||(!vid.movieStarted)){
		imgSwap(vid.videoID + "_playButton", pauseImgOn.src);
	}
	else{
		imgSwap(vid.videoID + "_playButton", playImgOn.src);
	}
	return true;
}

function playUp(obj)
{
	var vid = getVideo(obj);
	if (playMovie(obj)) {
		return true;
	}
	else{
		pauseUp(obj);
	}	
}

function pauseUp(obj)
{
	var vid = getVideo(obj);
	if (!vid.moviePaused && vid.movieStarted) {
		imgSwap(vid.videoID + "_playButton", playImgOff.src);
		var playButton = document.getElementById(vid.videoID + "_playButton");
		playButton.title = 'Đ';

		vid.animationTimeline.pauseElement();
		vid.moviePaused = true;
	}
}


function pauseEvent(obj)
{
	var vid = getVideo(obj);
	if (vid.movieFinished) {
		return;
	} else {
		pauseUp(obj);
	}
}

function resumeEvent(obj)
{
	var vid = getVideo(obj);
	if (vid.movieFinished) {
		return;
	} else {
		playMovie(obj);
	}
}



function stopDown(obj)
{
	var vid = getVideo(obj);
	if (!vid.movieStarted) {
		return false;
	}

	imgSwap(vid.videoID + "_stopButton", stopImgOn.src);
	setTimeout("stopButtonRecover('" + vid.videoID + "')", 100);
	stopElements(obj);
}

function stopUp(obj)
{
	var vid = getVideo(obj);
	if (!vid.movieStarted) {
		return false;
	}

	imgSwap(vid.videoID + "_stopButton", stopImgOff.src);
	imgSwap(vid.videoID + "_playButton", playImgOff.src);
}

function endMovie(obj)
{
	var vid = getVideo(obj);
	vid.bMovieIsActive = false;

	stopDown(obj);
}


function prevDown(obj)
{
	var vid = getVideo(obj);
	imgSwap(vid.videoID + "_prevButton", prevImgOn.src);
}

function prevUp(obj)
{
	var vid = getVideo(obj);
	img = document.getElementById(vid.videoID + "_prevButton");

	//if (img.src == prevImgOn.src) {
		imgSwap(vid.videoID + "_prevButton", prevImgOn.src);
		imgSwap(vid.videoID + "_prevButton", prevImgOff.src);

		vid.animationTimeline.pauseElement();
		var beforePaused = vid.moviePaused;

		nextScene(vid.videoID, -1);

		if (!beforePaused) {
			vid.animationTimeline.resumeElement();
		}
	//}
}

function nextDown(obj)
{
	var vid = getVideo(obj);
 	imgSwap(vid.videoID + "_nextButton", nextImgOn.src);
}

function nextUp(obj)
{
	var vid = getVideo(obj);
	img = document.getElementById(vid.videoID + "_nextButton");

	//if (img.src == nextImgOn.src) {
		imgSwap(vid.videoID + "_nextButton", nextImgOff.src);

		vid.animationTimeline.pauseElement();
		var beforePaused = vid.moviePaused;

		nextScene(vid.videoID, 1);

		if (!beforePaused) {
			vid.animationTimeline.resumeElement();
		}
	//}
}

function repeatDown(obj)
{
	var vid = getVideo(obj);

	if (!vid.bRepeat) {
	 	imgSwap(vid.videoID + "_repeatButton", repeatImgOn.src);
		vid.bRepeat = true;
	} else {
	 	imgSwap(vid.videoID + "_repeatButton", repeatImgOff.src);
		vid.bRepeat = false;
	}
}

function repeatUp(obj)
{
	return true;
}

function soundDown(obj)
{
}

function soundUp(obj)
{
	var vid = getVideo(obj);
	if(!vid.bMute){
		imgSwap(vid.videoID + "_soundButton", soundImgOn.src);
	}else{
		imgSwap(vid.videoID + "_soundButton", soundImgOff.src);
	}
}

function speedFastUp(obj)
{
	var vid = getVideo(obj);
	img = document.getElementById(vid.videoID + "_fastButton");

	//if (img.src == speedFastOn.src) {
		imgSwap(vid.videoID + "_fastButton", speedFastOff.src);
		if (!vid.movieFinished) {
			vid.speedChange(1);
		}
	//}
	return true;
}

function speedFastDown(obj)
{
	var vid = getVideo(obj);
	imgSwap(vid.videoID + "_fastButton", speedFastOn.src);
	return true;
}


function speedSlowUp(obj)
{
	var vid = getVideo(obj);
	img = document.getElementById(vid.videoID + "_slowButton");

	//if (img.src == speedSlowOn.src){
		imgSwap(vid.videoID + "_slowButton", speedSlowOff.src);
		if (!vid.movieFinished) {
			vid.speedChange(-1);
		}
	//}
	return true;
}

function speedSlowDown(obj)
{
	var vid = getVideo(obj);
	imgSwap(vid.videoID + "_slowButton", speedSlowOn.src);
	return true;
}



function stepBackUp(obj)
{
	var vid = getVideo(obj);
	img = document.getElementById(vid.videoID + "_stepBackButton");

	//if (img.src == stepBackImgOn.src) {
		imgSwap(vid.videoID + "_stepBackButton", stepBackImgOff.src);
		stepToTime(vid.videoID, -5);
	//}
	return true;
}

function stepBackDown(obj)
{
	var vid = getVideo(obj);
	imgSwap(vid.videoID + "_stepBackButton", stepBackImgOn.src);
	return true;
}


function stepForwardUp(obj)
{
	var vid = getVideo(obj);
	img = document.getElementById(vid.videoID + "_stepForwardButton");

	//if (img.src == stepForwardImgOn.src) {
		imgSwap(vid.videoID + "_stepForwardButton", stepForwardImgOff.src);
		stepToTime(vid.videoID, 5);
	//}
	return true;
}

function stepForwardDown(obj)
{
	var vid = getVideo(obj);
	imgSwap(vid.videoID + "_stepForwardButton", stepForwardImgOn.src);
	return true;
}



function resizeVideoToFSUp(obj)
{
	var vid = getVideo(obj);
	img = document.getElementById(vid.videoID + "_showFullButton");

	imgSwap(vid.videoID + "_showFullButton", showFullImgOff.src);
	linkTo("adica:video_fullscreen/" + vid.videoID);

	return true;
}

function resizeVideoToFSDown(obj)
{
	var vid = getVideo(obj);
	imgSwap(vid.videoID + "_showFullButton", showFullImgOn.src);
	return true;
}





function seekSliderMouseUp(obj)
{
	var vid = getVideo(obj);
	if(vid == null){
		return true;
	}

	if (vid.bsliderDown) {
		vid.animationTimeline.pauseElement();
		var beforePaused = vid.moviePaused;
		vid.moviePaused = true;

		vid.movieFinished = false;
		var seekt = vid.slider.value / 100;
		if (seekt > 1) {
			seekt = 1;
		}
		vid.timePosition = seekt * 100;

		seekTimeline(obj, seekt);
		vid.bsliderDown = false;

		if (seekt < 1) {
			//vid.movieFinished = false;
		} else {
			vid.movieFinished = true;
			beforePaused = true;
		}

		if (!beforePaused && seekt != 1) {
			playMovie(vid.videoID);

		}
	}
}


function seekSliderMouseDown(obj)
{
	vid = getVideo(obj);
	vid.bsliderDown = true;
	vid.bSeekInProgress = true;
	
	vid.slider.scrollXvalue = document.body.scrollLeft;
	vid.slider.scrollYvalue = document.body.scrollTop;
}



function seekTimeline(seekVidID, percent)
{
	var vid = getVideo(seekVidID);
	var entry = null;

	var timePosition = vid.TOTALTIME * percent;
	timePosition = Math.round(timePosition * 1000) / 1000;
	var tempTime = timePosition;

	var bFound = false;
	var entryNumber = null;

	for (var i=0; i<vid.TOTALENTRIES; i++) {
		entry = vid.playlist[i];

		var entryTime = Math.round(entry.totaltime * 1000) / 1000;

		if ((tempTime - entryTime) <= 0){
			bFound = true;
			entryNumber = i;
			break;
		} else {
			tempTime = tempTime - entryTime;
		}
	}

	entry = vid.playlist[entryNumber];
	if (!entry) {
		return; 
	}

	var seekto = tempTime + entry.begintime;
	var timeto = timePosition;
	seekToEntryNumber(seekVidID, entryNumber, seekto, timeto);

	if (percent == 1) {
		pauseUp(seekVidID);
		imgSwap(vid.videoID + "_playButton", playImgOff.src);
		var playButton = document.getElementById(vid.videoID + "_playButton");
		playButton.title = 'Đ';
	}
}


function stepToTime(obj, plusTime)
{
	var vid = getVideo(obj);
	var t = vid.animation.currTimeState.segmentTime;

	var seekTime = t + plusTime;
	if (seekTime > vid.TOTALTIME) {
		seekTime = vid.TOTALTIME;
	} else if (seekTime < 0) {
		seekTime = 0;
	}

	seekToTimeS2(vid.videoID, seekTime);
}




function seekToEntryNumber(obj, number, seekto, timeto)
{
	var vid = getVideo(obj);
	var nextEntry = vid.playlist[number];
	vid.NEXTDISABLE = true;

	if (!vid.movieStarted) {
		vid.moviePaused = true;
		vid.animationTimeline.beginElement();
		vid.animationTimeline.pauseElement();
	}

	vid.updateSpeed();

	if (vid.animationTimeline && vid.animationTimeline.currTimeState.isActive) {
		vid.animationTimeline.seekActiveTime(seekto);
	}

	if (!vid.moviePaused) {
		vid.animationTimeline.resumeElement();
	} else{
		vid.animationTimeline.pauseElement();
	}
	
	if (vid.animation && vid.animation.currTimeState.isActive){
		vid.animation.seekActiveTime(timeto);
	}

	updateScene(vid.videoID, timeto);
	vid.NEXTDISABLE = false;
	vid.bSeekInProgress = false;

	vid.movieStarted = true;
}


function updateScene(updateVidID, startTime)
{
	var vid = getVideo(updateVidID);
	var bSceneFound = false;
	var scene = null;
	
	for (var i=0; i<vid.scenelist.length; i++) {
		scene = vid.scenelist[i];
		if ((startTime >= scene.begin) && (startTime < scene.end)) {
			vid.currentScene = scene;
			bSceneFound = true;
			break;
		}
	}

	if (!bSceneFound) {
		if (vid.TOTALTIME <= startTime) {
			if (!vid.animationTimeline.currTimeState.isActive) {
				//vid.animationTimeline.beginElement();
			}
			//vid.animationTimeline.beginElement();
			
			if (vid.animationTimeline.currTimeState.isActive) {
				vid.animationTimeline.seekActiveTime(vid.TOTALTIME - 0.01);
			}
			vid.animationTimeline.pauseElement();

			vid.NEXTDISABLE = false;
			vid.timePosition = 100;
			vid.movieFinished = true;
			vid.moviePaused = true;

			imgSwap(vid.videoID + "_playButton", playImgOff.src);
			var playButton = document.getElementById(vid.videoID + "_playButton");
			playButton.title = 'Đ';
		}
		vid.currentScene = null;
	}
	else{
		if (vid.scenetime) {
			vid.scenetime.dur = vid.currentScene.end;  
		}
	}

}


function sceneEnd(endobj)
{
	var vid = getVideo(endobj);
	var t = vid.animation.currTimeState.segmentTime;
	if(vid.NEXTDISABLE){
		return;
	}

	if ((vid.bRepeat) && (!vid.bSeekInProgress)) {
		nextScene(endobj, 0);
		return;
	}

	if ((vid.movieStarted != false) && (vid.moviePaused != true)){
		updateScene(vid.videoID, t);
	}
}




function setBaseResource(str, bControlShow)
{
	BASERESOURCE = str;

	if (bControlShow == "true")
	{
		playImgOn.src   = BASERESOURCE + "pause_On.gif";
		playImgOff.src  = BASERESOURCE + "pause_Off.gif";
		playImgOver.src = BASERESOURCE + "pause_Over.gif";
		pauseImgOn.src   = BASERESOURCE + "play_On.gif";
		pauseImgOff.src  = BASERESOURCE + "play_Off.gif";
		pauseImgOver.src = BASERESOURCE + "play_Over.gif";

		stopImgOn.src   = BASERESOURCE + "stop_On.gif";
		stopImgOff.src  = BASERESOURCE + "stop_Off.gif";
		stopImgOver.src = BASERESOURCE + "stop_Over.gif";
		prevImgOn.src   = BASERESOURCE + "back_On.gif";
		prevImgOff.src  = BASERESOURCE + "back_Off.gif";
		prevImgOver.src = BASERESOURCE + "back_Over.gif";
		nextImgOn.src   = BASERESOURCE + "forward_On.gif";
		nextImgOff.src  = BASERESOURCE + "forward_Off.gif";
		nextImgOver.src = BASERESOURCE + "forward_Over.gif";
		repeatImgOn.src   = BASERESOURCE + "repeat_On.gif";
		repeatImgOff.src  = BASERESOURCE + "repeat_Off.gif";
		repeatImgOver.src = BASERESOURCE + "repeat_Over.gif";
		speedFastOn.src   = BASERESOURCE + "speedFast_On.gif";
		speedFastOff.src  = BASERESOURCE + "speedFast_Off.gif";
		speedFastOver.src = BASERESOURCE + "speedFast_Over.gif";
		speedSlowOn.src   = BASERESOURCE + "speedSlow_On.gif";
		speedSlowOff.src  = BASERESOURCE + "speedSlow_Off.gif";
		speedSlowOver.src = BASERESOURCE + "speedSlow_Over.gif";
		soundImgOn.src   = BASERESOURCE + "sound_On.gif";
		soundImgOff.src  = BASERESOURCE + "sound_Off.gif";
		soundImgOver.src = BASERESOURCE + "sound_Over.gif";

		stepBackImgOn.src   = BASERESOURCE + "stepBack_On.gif";
		stepBackImgOff.src  = BASERESOURCE + "stepBack_Off.gif";
		stepBackImgOver.src = BASERESOURCE + "stepBack_Over.gif";
		stepForwardImgOn.src   =  BASERESOURCE + "stepForward_On.gif";
		stepForwardImgOff.src  =  BASERESOURCE + "stepForward_Off.gif";
		stepForwardImgOver.src =  BASERESOURCE + "stepForward_Over.gif";

		showFullImgOn.src   = BASERESOURCE + "showFull_On.gif";
		showFullImgOff.src  = BASERESOURCE + "showFull_Off.gif";
		showFullImgOver.src = BASERESOURCE + "showFull_Over.gif";
	}
}



function imgSwap(id, imagesrc)
{
	var theImg=document.getElementById(id);
	theImg.setAttribute("src", imagesrc);
}

function overButton(obj, overFlag) 
{
	var length = obj.src.length;
	var endPos = length -1;
	var c;
	var objSrc;

	for (var i=endPos; i >= 0; i--) {
		c = obj.src.charAt(i);
		if (c == '_') {
			objSrc = obj.src.substring(0,i);
			break;
		}
	}

	if (overFlag == 'over' && obj.src == objSrc + "_Off.gif") {
		imgSwap(obj.id, objSrc + "_Over.gif");
	} else if (overFlag == 'out' && obj.src == objSrc + "_Over.gif") {
		imgSwap(obj.id, objSrc + "_Off.gif");
	}
}



function uisetup(videoID, height, width, top, left, uicolor, bPlay, bStop, bSeek, bVol, bSpeed, bPrevSkip, bNextSkip, bRepeat, bTime, bMute, bStep, bFull)
{
	if (videoLevel == 1) {
		bMute = false;
		bVol  = false;
		//bFull = false;
	}

	requestedWidth[videoID] = width;
	requestedHeight[videoID] = height;

	var topBar = document.getElementById(videoID + "_MenuBar");
	var uiSlider = document.getElementById(videoID + "_oSlider");
	var uiVSlider = document.getElementById(videoID + "_vSlider");
	var panel = document.getElementById(videoID + "_ControlPanel");
	panel.style.display = "block";
	panel.style.top = top;
	panel.style.left = left;

	if (isImage(uicolor)) {
		panel.style.backgroundColor = "transparent";
		uiSlider.style.backgroundColor = "transparent";
		uiVSlider.style.backgroundColor = "transparent";
		panel.style.backgroundImage = "url('" + uicolor + "')";
	} else{
		panel.style.backgroundColor = uicolor;
		uiSlider.style.backgroundColor = uicolor;
		uiVSlider.style.backgroundColor = uicolor;
	}

	uitoggle(videoID + "_playButton", bPlay);
	uitoggle(videoID + "_stopButton", bStop);
	uitoggle(videoID + "_oSlider", bSeek);

	var ctrlObj = document.getElementById(videoID + "_oLeft");
	if (ctrlObj) {
		if(bSeek){
			ctrlObj.style.display = 'inline';
		}else{
			ctrlObj.style.display = 'none';
		}
	}

	ctrlObj = document.getElementById(videoID + "_oRight");
	if(ctrlObj){
		if(bSeek){
			ctrlObj.style.display = 'inline';
		}else{
			ctrlObj.style.display = 'none';
		}
	}

	uitoggle(videoID + "_prevButton", bPrevSkip);
	uitoggle(videoID + "_nextButton", bNextSkip);
	uitoggle(videoID + "_repeatButton", bRepeat);
	uitoggle(videoID + "_slowButton", bSpeed);
	uitoggle(videoID + "_fastButton", bSpeed);
	uitoggle(videoID + "_soundButton", bMute);
	uitoggle(videoID + "_vSlider", bVol);
	uitoggle(videoID + "_stepBackButton", bStep);
	uitoggle(videoID + "_stepForwardButton", bStep);
	uitoggle(videoID + "_showFullButton", bFull);


	ctrlObj = document.getElementById(videoID + "_vLeft");
	if(ctrlObj){
		if(bVol){
			ctrlObj.style.display = 'inline';
		}else{
			ctrlObj.style.display = 'none';
		}
	}
	ctrlObj = document.getElementById(videoID + "_vRight");
	if(ctrlObj){
		if(bVol){
			ctrlObj.style.display = 'inline';
		}else{
			ctrlObj.style.display = 'none';
		}
	}

	r2Count = (bPrevSkip? 1:0) + (bNextSkip? 1:0) + (bRepeat? 1:0) + (bSpeed? 2:0) + (bMute? 1:0) + (bVol? 1:0) + (bStep? 2:0) + (bFull? 1:0);

	var callString = "widthCalculate('" + videoID + "');";
	var timerID = setTimeout(callString, 500);
	heightCalculate(videoID);

	ctrlObj = document.getElementById(videoID + "_lbot");
	if(ctrlObj){
		if(bSeek){
			ctrlObj.style.top = 45;
		}else{
			ctrlObj.style.top = 21;
		}
	}
	ctrlObj = document.getElementById(videoID + "_rbot");
	if(ctrlObj){
		if(bSeek){
			ctrlObj.style.top = 45;
		}else{
			ctrlObj.style.top = 21;
		}
		ctrlObj.style.left = width - 7;
	}
}


function uitoggle(idName, show)
{
	var ctrlObj = document.getElementById(idName);
	if (ctrlObj) {
		if (show) {
			ctrlObj.style.display = 'inline';
			if(ctrlObj.id=='oSlider'){
				ctrlObj.style.width="50px";
				ctrlObj.style.display="inline";
			}
			uiHashtable[idName] = parseInt(ctrlObj.currentStyle.width);
		} else {
			ctrlObj.style.display = 'none';
			uiHashtable[idName] = 0;
		}
	}
}



function widthCalculate(videoID)
{
	var row1Width = 6;
	for(var i=0; i<firstRow.length; i++){
		width = uiHashtable[videoID + "_" + firstRow[i]];
		row1Width += width;
	}
	var row2Width = 6;
	var row2Count = 0;
	for(var i=0; i<secondRow.length; i++){
		width = uiHashtable[videoID + "_" + secondRow[i]];
		row2Width += width;
		if(width > 0){
			row2Count++;
		}
	}

	var minWidth = (row1Width > row2Width) ? row1Width : row2Width;

	var finalWidth = (minWidth > requestedWidth) ? minWith : requestedWidth[videoID];

	var controlPanel = document.getElementById(videoID + "_ControlPanel");
	var borderWidth = parseInt(controlPanel.currentStyle.borderWidth);
	borderWidth = borderWidth * 2 + 4;

	var slider = document.getElementById(videoID + '_oSlider');
	var vslider = document.getElementById(videoID + '_vSlider');
	vslider.style.width = 26;
	vslider.value = 100;

	var bSliderExist = (slider.offsetWidth > 0) ? true : false;

	if ((row1Width < finalWidth) && (bSliderExist)) {
		difference = requestedWidth[videoID] - row1Width;
		originalWidth = slider.offsetWidth;
		newWidth = originalWidth + difference - borderWidth;
		slider.style.width = newWidth;
	}

	if ((!bSliderExist)){
		panel = document.getElementById(videoID + '_MenuBar');
	}

	ctrlPanel = document.getElementById(videoID + '_ControlPanel');
	ctrlPanel.style.visibility = "visible";
	ctrlPanel.style.display = "block";
}


function heightCalculate(videoID)
{
	var controlHeight = 0;
	var controlPanel = document.getElementById(videoID + '_ControlPanel');
	var controlHeight = controlPanel.offsetHeight;
	var finalHeight = (controlHeight > requestedHeight[videoID]) ? controlHeight : requestedHeight[videoID];

	var borderHeight = parseInt(controlPanel.currentStyle.borderWidth);
	borderHeigh = borderHeight * 2;
	
	controlPanel.style.height = finalHeight - borderHeight;
}


function isImage(str)
{
	if (typeof(str) == "string") {
		str = str.toLowerCase() 
		if ((str.indexOf(".gif")!= -1) || (str.indexOf(".jpg") != -1) || (str.indexOf(".bmp") != -1)) {
			return true;
		}
	}
	return false;
}








function buffProgress(videoID, id) 
{
	var prog  = document.getElementById(id + "Prog");
	var gage  = document.getElementById(id + "Gage");
	var zone  = document.getElementById(id + "GageZone");
	var state = document.getElementById(id + "State");
	var percent = document.getElementById(id + "Percent");
	var kamiIndex  = document.getElementById(id + "KamiIndex");

	var nIndex = 0;
	var video = getVideo(videoID);

	if (videoLevel != 0) {
		percent.innerText = "";
		var currTime = video.animationTimeline.currTimeState.activeTime;

		var durTime;
		var i;
		for (i=0; i<KamiTime.length; i++) {
			var beginTime = video.scenelist[i].begin;
			var endTime = video.scenelist[i].end;
			durTime = endTime - beginTime;
			if (beginTime <= currTime && endTime > currTime) {
				break;
			}
		}
		if (i != KamiTime.length) {
			percent.innerText = parseInt(endTime - currTime);
			nIndex = i + 1;
		}
	}
	
	if (video != null) {
		if (video.moviePaused || video.movieFinished) {
			video.buffering = false;
			state.innerText = "~";
		} 
		else {
			state.innerText = "Đ";
			if (videoLevel == 1) {
				state.innerText = "Đ";

				zone.style.width = "0%";
				kamiIndex.style.width = "50%";
				kamiIndex.style.textAlign = "center";
				kamiIndex.style.backgroundColor = "#ABABAE";
				total = KamiTime.length;
				kamiIndex.innerText = nIndex + "/" + total;
			}
		}
	}
}





function uninit() {
	UNLOADING = true;
}



function tagElem(tagName){
	this.tagNamee=tagName;
	this.attrCount = 0;
	this.attrHash = new Object();
	this.subElems = new Array();

	function getTagString(){
		start = '<' + this.tagNamee;

		for (var n in this.attrHash) {
			attribName = n;
			attribValue = this.attrHash[n];
			attribStr = ' ' + attribName + '="' + attribValue + '"';
			start = start + attribStr;
		}
		start = start + '/>';
		return start;
	}

	function setAttribute(name, value){
		this.attrHash[name] = value;
	}

	function getAttribute(name){
		return this.attrHash[name];
	}

	function addSubElement(subtagElem){
		len = this.subElems.length;
		this.subElems[len] = subtagElem;
	}

	this.setAttribute = setAttribute;
	this.getAttribute = getAttribute;
	this.getTagString = getTagString;
	this.addSubElement = addSubElement;
}




function logIt(evt, num)
{
	var val = 0;
	var mainWin = document.getElementById("debugWindow");
	if(!mainWin) return;


	if(typeof(num)!="undefined"){
		val = num;
	}
	str = "debugW" + val;

	dw = document.getElementById(str);
	if(dw){
		dw.innerHTML += evt + '<br/>';
		dw.doScroll("scrollbarPageDown");
	}else{
		var newButton = document.createElement("button");
		newButton.innerHTML ="Clear";
		newButton.attachEvent("onclick", clearForm); 
		newButton.setAttribute("id2",str);

		var newButton2 = document.createElement("button");
		newButton2.innerHTML ="Hide";
		newButton2.attachEvent("onclick", toggleDebug); 
		newButton2.setAttribute("id2",str);

		mainWin.appendChild(newButton);
		mainWin.appendChild(newButton2);
		
		var newDebug = document.createElement("div");
		newDebug.setAttribute("id", str);
		newDebug.className="debugWin";
		mainWin.appendChild(newDebug);
		newDebug.innerHTML += evt + '<br/>';
	}
}

function clearForm(evt){
	elem = window.event.srcElement;
	str = elem.id2;
	dw = document.getElementById(str);
	if(dw){
		dw.innerHTML ="";
	}
}

function toggleDebug(evt){
	elem = window.event.srcElement;
	str = elem.id2;
	dw = document.getElementById(str);
	if(dw){
		if(dw.style.display == "none"){
			dw.style.display = "block";
			elem.innerHTML = "Hide";
		}else{
			dw.style.display = "none";
			elem.innerHTML = "Show";
		}
	}
}




function seekEvent(seekVidID, seektime, waitFlag, finalFlag, count) 
{
	var vid = getVideo(seekVidID);

	if (!vid.bMovieIsActive) {
		setTimeout("seekEvent('" + seekVidID + "'," + seektime + "," + waitFlag + "," + finalFlag + "," + count + ")", 20);
		return;
	}

	vid.animationTimeline.pauseElement();
	var beforePaused = vid.moviePaused;
	vid.moviePaused = true;

	seekToTime(seekVidID, seektime);

	var percent = seektime / vid.TOTALTIME;
	percent = Math.round(percent * 1000) / 1000;
	if (percent > 1) {
		percent = 1;
	}

	if (!beforePaused && percent != 1) {
		playMovie(seekVidID);
	}
	
	if (beforePaused) {
		if (vid.animationTimeline.currTimeState.isActive) {
			vid.animationTimeline.seekActiveTime(seektime + SEEK_AFTER_CORRECT);
		}
	}
}


function playEvent(obj, waitFlag, finalFlag, count) 
{
	var vid = getVideo(obj);
	playMovie(vid.videoID, waitFlag);
}



function pauseEvent(obj, waitFlag, finalFlag, count) 
{
	var vid = getVideo(obj);
	if (vid.movieFinished) {
		return;
	} else {
		pauseUp(obj);
	}
}


function resumeEvent(obj, waitFlag, finalFlag, count) 
{
	var vid = getVideo(obj);
	if (vid.movieFinished) {
		return;
	} else {
		playMovie(obj);
	}
}


function stopEvent(obj, waitFlag, finalFlag, count) 
{
	var vid = getVideo(obj);
	stopDown(vid.videoID);
}


function seekToPrevScene(obj, waitFlag, finalFlag, count)
{
	var vid = getVideo(obj);
	prevUp(vid.videoID, -1);
}


function seekToNextScene(obj, waitFlag, finalFlag, count)
{
	var vid = getVideo(obj);
	nextUp(vid.videoID, 1);
}


function speedFast(obj, waitFlag, finalFlag, count)
{
	var vid = getVideo(obj);
	if (!vid.movieFinished) {
		vid.speedChange(1);
	}
	return true;
}


function speedSlow(obj, waitFlag, finalFlag, count)
{
	var vid = getVideo(obj);

	if(!vid.movieFinished) {
		vid.speedChange(-1);
	}
	return true;
}


function stepBackEvent(obj, waitFlag, finalFlag, count)
{
	var vid = getVideo(obj);
	stepToTime(vid.videoID, -5);
}


function stepForwardEvent(obj, waitFlag, finalFlag, count)
{
	var vid = getVideo(obj);
	stepToTime(vid.videoID, 5);
}

function soundChange(obj, vol)
{
}


function soundSwitch(obj, waitFlag, finalFlag, count)
{
}

function soundSwitchLater(obj, waitFlag, finalFlag, count)
{
}



function videoIsActive(obj) 
{
	var vid = getVideo(obj);
	var elem = document.getElementById(vid.videoID);
	if (elem == null) {
		return false;
	}
	var disp = elem.getAttribute('style').display;
	var vis = elem.getAttribute('style').visibility;
	if (disp == "none" || vis == "hidden") {
		return false;
	}
	return true;
}



