var SVG_PLUGIN_INSTALLED = 0;

function setPluginState(bInstall) {
	SVG_PLUGIN_INSTALLED = bInstall;
}


function checkPlugin()
{
	var axObj = null;
	var version = "";
	try {
		axObj = new ActiveXObject("Adobe.SVGCtl");
		version = axObj.getSVGViewerVersion();
		if (typeof(version) == "string"){
			var str = version.split(";");
			if (str[1] >= 3.0) {
				setPluginState(1);
			} else {
				setPluginState(0);
			}
		}
	}
	catch(e) {
		setPluginState(0);
	}
}


var animationRegions = new Object();
var svgSupport = new Object();
var SVGINITIALIZED = false;
var eventList = new Object();


function svgEventListener(evt)
{
	var svgdoc  = evt.getTarget().getOwnerDocument();
	if (svgdoc == null) {
		return;
	}
		
    var svgRoot = svgdoc.getDocumentElement();
    if (svgRoot == null) {
		return;
	}
	
	var vidID = svgRoot.id;
	var svgEventType = evt.type;
	var svgPolyID = evt.target.id;

	var eventID = vidID + "_" + svgPolyID + "_" + svgEventType;
	var execStr = eventList[eventID];
	
	eval(execStr);
}


function addSVGHandler(vidID, polyID, eventType, execString)
{
	if (svgSupport[vidID]) 
	{
		var eventID = vidID + "_" + polyID + "_" + eventType;
		eventList[eventID] = execString;
		
		var svgdoc = getSVGdoc(vidID);
		if (svgdoc == null) {
			return;
		}
		
		var svgObj = svgdoc.getElementById(polyID);
		if (svgObj) {
			svgObj.addEventListener(eventType, window.svgEventListener, false);
		}
	}

	return true;
}


function syncSVGTime(vidToSync)
{
	if (SVG_PLUGIN_INSTALLED == 0) {
		return ;
	}

	var sVid = getVideo(vidToSync);
	if (!sVid.moviePaused) {
		var svgtime = sVid.animation.currTimeState.segmentTime;
		svgSeek(vidToSync, svgtime);
	}
	return;
}


var zoomW = null;
function svgZoom(zoomlevel)
{
	var svgdoc = getSVGdoc2("movieName1");
	if (svgdoc == null) {
		return;
	}
	zoomW(2);
}


function svgStop(videoID)
{
	if (SVG_PLUGIN_INSTALLED == 0) {
		return ;
	}
	if(!svgSupport[videoID]) return;

	var svgdoc = getSVGdoc(videoID);
	if (svgdoc == null) {
		return;
	}
	svgdoc.pauseAnimations();
	svgdoc.setCurrentTime(0);
}


function svgPause(videoID)
{
	if (SVG_PLUGIN_INSTALLED == 0) {
		return ;
	}
	if(!svgSupport[videoID]) return;

	var svgdoc = getSVGdoc(videoID);
	if (svgdoc == null) {
		return;
	}
	svgdoc.pauseAnimations();
}


function svgResume(videoID)
{
	if (SVG_PLUGIN_INSTALLED == 0) {
		return ;
	}
	
	if(!svgSupport[videoID]) return;

	var svgdoc = getSVGdoc(videoID);
	if (svgdoc == null) {
		return;
	}
	svgdoc.unpauseAnimations();
}


function svgSeek(videoID, svgtime)
{
	if (SVG_PLUGIN_INSTALLED == 0) {
		return ;
	}
	if(!svgSupport[videoID]) return;

	var svgdoc = getSVGdoc(videoID);
	if (svgdoc == null) {
		return;
	}
	svgdoc.setCurrentTime(svgtime);	
}

function loadData(videoID)
{
	var xmlStr = videoID + ".xml";
	if(svgSupport[videoID]){
		loadPolyData(videoID, xmlStr);
		writeRegion(videoID);
	}
}


function animateRegion(videoID, xmlfile)
{
	this.videoID = videoID;
	this.xmldoc = null;
	this.moveRegionArray = new Array();
	this.polygonArray = new Array();

	this.xmldoc = new ActiveXObject("Microsoft.XMLDOM");
	this.xmldoc.async = false;
	this.xmldoc.load(xmlfile);
}


function getSVGdoc(videoID)
{
	if (SVG_PLUGIN_INSTALLED == 0) {
		return null;
	}

	try{
		var str = videoID + "_svg";
		var svgPlayer = document.getElementById(str);
		if (svgPlayer) {
			var svgdoc = svgPlayer.getSVGDocument();
			return svgdoc.getDocumentElement();
		} else {
			return null;
		}
	}
	catch(e) {
		return null;
	}
}


function getSVGdoc2(videoID)
{
	if (SVG_PLUGIN_INSTALLED == 0) {
		return null;
	}

	try{
		var str = videoID + "_svg";
		var svgPlayer = document.getElementById(str);
		if (svgPlayer) {
			var svgdoc = svgPlayer.getSVGDocument();
			return svgdoc;
		} else {
			return null;
		}
	}
	catch(e) {
		return null;
	}
}

function createSVGElements()
{
	if (SVG_PLUGIN_INSTALLED == 0) {
		for (var vidID in animationRegions) {
			svgSupport[vidID] = false;
			var str = vidID + "_svg";
			var svgPlayer = document.getElementById(str);
			svgPlayer.style.visibility = 'hidden';
		}
		return;
	}

	var bSuccess = true;
	for (var vidID in animationRegions) {
		if(svgSupport[vidID]) {
			bSuccess = createSVGElement(vidID);
			if (bSuccess == false) {
				break;
			}
		}
	}

	if (bSuccess == false) {
		SVG_PLUGIN_INSTALLED = 0;
		for (var vidID in animationRegions) {
			svgSupport[vidID] = false;
			var str = vidID + "_svg";
			var svgPlayer = document.getElementById(str);
			svgPlayer.style.visibility = 'hidden';
		}
		return;
	}
	
	svgEvents();
	SVGINITIALIZED = true;
}


function createSVGElement(videoID)
{
	if (SVG_PLUGIN_INSTALLED == 0) {
		return false;
	}

	var svgdoc = getSVGdoc2(videoID);
	if (svgdoc == null) {
		return false;
	}
	var svgRoot = svgdoc.getDocumentElement();
	var polygonArray = animationRegions[videoID].polygonArray;

	for (var k=0; k<polygonArray.length; k++) 
	{
		var tagElement = polygonArray[k];
		var elementName = tagElement.tagNamee;
		var svgObj = svgdoc.createElement(elementName);
		var theid = null;

		for (var n in tagElement.attrHash) {
			var attribName = n;
			var attribValue = tagElement.attrHash[n];
			svgObj.setAttribute(attribName, attribValue);
			if(attribName =="id"){
				theid = attribValue;
			}
		}

		for (var h=0; h <tagElement.subElems.length; h++) 
		{
			var animationElement = tagElement.subElems[h];
			var animationName = animationElement.tagNamee;
			var animateObj = svgdoc.createElement(animationName);
			for (var n in animationElement.attrHash) {
				var attribName = n;
				var attribValue = animationElement.attrHash[n];
				animateObj.setAttribute(attribName, attribValue);
			}
			svgObj.appendChild(animateObj);
		}
		
		var mainObj = svgdoc.getElementById("mainArea");
		mainObj.appendChild(svgObj);
	}

	svgRoot.setAttribute("id", videoID);
	INITIALIZED = true;
	
	return true;
}


function changeSVGSize(videoID, beginSize, endSize, dur)
{
	if (SVG_PLUGIN_INSTALLED == 0) {
		return ;
	}
	var svgdoc = getSVGdoc2(videoID);
	if (svgdoc == null) {
		return;
	}
	var animateObj = svgdoc.getElementById("sizeAnimate");

	animateObj.setAttribute("from", beginSize);
	animateObj.setAttribute("to", endSize);
	animateObj.setAttribute("dur", dur);
	animateObj.beginElement();
}


function svgStartO(videoID, objID, animationID, timeObj)
{
	if(!SVGINITIALIZED) return true;
	var vid = getVideo(videoID);
	var progress = timeObj.currTimeState.progress;

	var svgdoc = getSVGdoc(videoID);
	if (svgdoc == null) {
		return;
	}
	var svgAni = svgdoc.getElementById(animationID);
	var svgObj = svgdoc.getElementById(objID);

	var svgstyle = svgObj.getStyle();
	if(svgstyle){
		svgstyle.setProperty ('visibility', 'visible');
	}
}


function svgPauseO(videoID, animationID)
{
	if(!SVGINITIALIZED) return true;
}


function svgResumeO(videoID, objID){

}


function svgEndO(videoID, objID, animationID)
{
	if(UNLOADING) return;
	if(!SVGINITIALIZED) return true;
	
	var svgdoc = getSVGdoc(videoID);
	if (svgdoc == null) {
		return;
	}
	
	var svgAni = svgdoc.getElementById(animationID);
	var svgObj = svgdoc.getElementById(objID);

	var svgstyle = svgObj.getStyle();
	if (svgstyle) {
		svgstyle.setProperty ('visibility', 'hidden');
	}
}


function writeRegion(videoID)
{
	var regionArray = animationRegions[videoID].moveRegionArray
	for (var i=0; i<regionArray.length; i++) {
		var reg = regionArray[i];
		var a = reg.getTagString();

		document.open();
		document.write(a);
		document.close();
	}
}


function setupTagData(node, name)
{
	var tagElement = new tagElem(name);

	var attrNodeMap = node.attributes;
	for (var k=0; k<attrNodeMap.length; k++){
		var attribute = attrNodeMap.item(k);
		tagElement.setAttribute(attribute.nodeName, attribute.nodeValue);
	}
	
	return tagElement;
}


var bSvgPause = false;

function setupRegionTagData(videoID, node, objID)
{
	var tagElement = new tagElem("t:animate");
	var animateID = node.getAttribute("id");
	var begin = node.getAttribute("begin");
	
	var dur = node.getAttribute("dur");
	tagElement.setAttribute("begin", begin);
	tagElement.setAttribute("dur", dur);

	var onBeginVal = "svgStartO('" + videoID + "','" + objID + "','" + animateID + "',this)";
	var onPauseVal = "svgPauseO('" + videoID + "','" + animateID + "')"; 
	var onResumeVal = "svgResumeO('" + videoID + "','" + objID + "')";
	var onEndVal = "svgEndO('" + videoID + "','" + objID + "','" + animateID + "')";

	tagElement.setAttribute("onbegin", onBeginVal);
	tagElement.setAttribute("onpause", onPauseVal);
	tagElement.setAttribute("onresume", onResumeVal);
	tagElement.setAttribute("onend", onEndVal);
	tagElement.setAttribute("fill", "hold");
	
	return tagElement;
}


function loadPolyData(videoID, xmlfile)
{
	var aniRegion = new animateRegion(videoID, xmlfile);

	var xmldoc = aniRegion.xmldoc;
	var polygonArray = aniRegion.polygonArray;
	var moveRegionArray = aniRegion.moveRegionArray;

	var polylist = xmldoc.getElementsByTagName("polygon");
	for (var j=0;j<polylist.length;j++) 
	{
		var polyElem = polylist.item(j);
		var objIdName = polyElem.getAttribute("id");
		
		var polyTag = setupTagData(polyElem, "polygon");
		for (var m=0; m < polyElem.childNodes.length; m++) {
			var region = setupRegionTagData(videoID, polyElem.childNodes[m], objIdName);
			var animateElem = setupTagData(polyElem.childNodes[m], polyElem.childNodes[m].nodeName);
			polyTag.addSubElement(animateElem);
				
			moveRegionArray[moveRegionArray.length]=region;
		}
		polygonArray[j] = polyTag;
	}
	
	polylist = xmldoc.getElementsByTagName("ellipse");
	for (var j=0; j<polylist.length; j++) 
	{
		var polyElem = polylist.item(j);
		var objIdName = polyElem.getAttribute("id");
		
		var polyTag = setupTagData(polyElem, "ellipse");
		for (var m=0; m < polyElem.childNodes.length; m++) {
			var region = setupRegionTagData(videoID, polyElem.childNodes[m], objIdName);
			var animateElem = setupTagData(polyElem.childNodes[m], polyElem.childNodes[m].nodeName);
			polyTag.addSubElement(animateElem);
				
			moveRegionArray[moveRegionArray.length]=region;
		}
		polygonArray[polygonArray.length] = polyTag;
	}

	polylist = xmldoc.getElementsByTagName("rect");
	for (var j=0; j<polylist.length; j++) 
	{
		var polyElem=polylist.item(j);
		var objIdName = polyElem.getAttribute("id");
		
		var polyTag = setupTagData(polyElem, "rect");
		for(var m=0; m < polyElem.childNodes.length; m++) {
			var region = setupRegionTagData(videoID, polyElem.childNodes[m], objIdName);
			var animateElem = setupTagData(polyElem.childNodes[m], polyElem.childNodes[m].nodeName);
			polyTag.addSubElement(animateElem);
				
			moveRegionArray[moveRegionArray.length] = region;
		}
		polygonArray[polygonArray.length] = polyTag;
	}
	
	animationRegions[videoID] = aniRegion;
}




